﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MovieDatabase
{
    public partial class Form1 : Form
    {
        Database db;
        Boolean databasecreated = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnAddMovie_Click(object sender, EventArgs e)
        {
            addMovie();
        }

        private void addMovie()
        {
            if(!databasecreated)
            {
                db = new Database();
                databasecreated = true;
            }
            if (txtTitle.Text != "" && txtCategory.Text != "")
            {
                string mt = txtTitle.Text;
                string mc = txtCategory.Text;
                int my = (int)nudYear.Value;
                string mf = comboBox1.SelectedItem.ToString();

                Movie m = new Movie(mt, mc, my, mf);
                db.movies.Add(m);
                clearFields();
                txtTitle.Focus();
            }
            else
            {
                MessageBox.Show("Please fill out all of the fields.");
            }
        }

        private void clearFields()
        {
            txtTitle.Text = "";
            txtCategory.Text = "";
            nudYear.Value = 2000;
        }

        private void listMovies()
        {
            lstResults.Items.Clear();
            foreach (Movie ml in db.movies)
            {
                lstResults.Items.Add(ml.moviename);
            }
        }

        private void saveToFile()
        {
            //string fileName = @"C:\Projects\Movies.txt";
            //StreamWriter wr = new StreamWriter(fileName);
            //foreach (Movie m in db.movies)
            //{
            //    wr.WriteLine(m.saveMovie());
            //}
            //wr.Flush();
            //wr.Close();
            try
            {
                BinaryFormatter formatter = new BinaryFormatter();
                FileStream output = new FileStream("movies.db", FileMode.OpenOrCreate, FileAccess.Write);
                formatter.Serialize(output, db);
                output.Close();
            }
            catch(IOException)
            {
                MessageBox.Show("File Save Failed");
            }
        }

        private void exitProg()
        {
            Application.Exit();
        }

        private void btnClearFields_Click(object sender, EventArgs e)
        {
            clearFields();
        }

        private void btnListMovies_Click(object sender, EventArgs e)
        {
            listMovies();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            saveToFile();
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            exitProg();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            exitProg();
        }

        private void addMovieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            addMovie();
        }

        private void clearFieldsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            clearFields();
        }

        private void listMovieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listMovies();
        }

        private void saveToFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveToFile();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Program By: David Eisenberg\nProject 7\n4-8-2014");
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
        }

        private void nudYear_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)13)
            {
                addMovie();
            }
        }

      

        private void btnLoadFile_Click(object sender, EventArgs e)
        {
            BinaryFormatter reader = new BinaryFormatter();
            FileStream input = new FileStream("movies.db", FileMode.Open, FileAccess.Read);
            try
            {
                db = (Database)reader.Deserialize(input);
                databasecreated = true;
                input.Close();
            }
            catch(SerializationException)
            {
                MessageBox.Show("Loading Failed");
            }
        }

        private void lstResults_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                MessageBox.Show(db.movies.ElementAt(lstResults.SelectedIndex).getMovie());
            }
            catch(ArgumentOutOfRangeException)
            {
                MessageBox.Show("Please select a valid choice.");
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string searchtext = textBox1.Text;
            char[] search = searchtext.ToCharArray();
            int searchmethod = 0;
            if (radioButton1.Checked)
            {
                searchmethod = 1;
            }
            else if (radioButton2.Checked)
            {
                searchmethod = 2;
            }
            else if (radioButton3.Checked)
            {
                searchmethod = 3;
            }
            else if (radioButton4.Checked)
            {
                searchmethod = 4;
            }
            foreach (Movie m in db.movies)
            {
                switch (searchmethod)
                {
                    case 0:
                    {
                        MessageBox.Show("Please select a search method");
                        break;
                    }
                    case 1:
                    {
                        if (m.moviename.StartsWith(searchtext))
                        {
                            MessageBox.Show(m.getMovie());
                        }
                        break;
                    }
                    case 2:
                    {
                        if (m.moviename.IndexOfAny(search) >= 0)
                        {
                            MessageBox.Show(m.getMovie());
                        }
                        break;
                    }
                    case 3:
                    {
                        if (m.moviename.EndsWith(searchtext))
                        {
                            MessageBox.Show(m.getMovie());
                        }
                        break;
                    }
                    case 4:
                    {
                        if(m.moviename.LastIndexOfAny(search) >= 0)
                        {
                            MessageBox.Show(m.getMovie());
                        }
                        break;
                    }
                }
               
               
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Reports r = new Reports();
            r.Visible = true;
            r.getDatabase(db);
            
        }
    }
}
