﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace dseproject5
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Team> teams = new List<Team>();

            Team ana = new Team("Anaheim", 75, 4.20, 691);
            Team bal = new Team("Baltimore", 63, 4.67, 687);
            Team bos = new Team("Boston", 82, 4.15, 772);
            Team chi = new Team("Chicago White Sox", 83, 4.5, 798);
            Team cle = new Team("Cleveland", 91, 4.64, 897);
            Team det = new Team("Detroit", 66, 5.01, 724);
            Team kan = new Team("Kansas City", 65, 4.87, 729);
            Team min = new Team("Minnesota", 85, 4.51, 771);
            Team nyy = new Team("New York Yankees", 95, 4.02, 804);
            Team oak = new Team("Oakland", 102, 3.59, 884);

            teams.Add(ana);
            teams.Add(bal);
            teams.Add(bos);
            teams.Add(chi);
            teams.Add(cle);
            teams.Add(det);
            teams.Add(kan);
            teams.Add(min);
            teams.Add(nyy);
            teams.Add(oak);

            var teamQuery1 = from team in teams
                             orderby team.wins ascending
                             select team;
            var teamQuery2 = from team in teams
                             orderby team.runs ascending
                             select team;
            var teamQuery3 = from team in teams
                             orderby team.era ascending
                             select team;
            var teamQuery4 = from team in teams
                             let rpw = team.runs / team.wins
                             where rpw >= 9
                             orderby rpw ascending
                             select string.Format("{0,-20} {1,5}", team.TeamName, rpw);

            Console.WriteLine("{0,-20} {1, 5} {2, 5} {3, 15}", "Team", "Wins", "  E.R.A", "Runs Scored");
            Console.WriteLine("{0,-20} {1, 5} {2, 5} {3, 11}", "------", "------", "-------", "   ------------");
            foreach(Team t in teamQuery1)
            {
                //Console.WriteLine("{0,1}", t);
                Console.WriteLine("{0,-20} {1,5} {2,6} {3,12}", t.TeamName, t.wins, t.era, t.runs);
            }
            Console.WriteLine("Sorted By Number of Wins Ascending\n\n");
            Console.WriteLine("{0,-20} {1, 5} {2, 5} {3, 15}", "Team", "Wins", "  E.R.A", "Runs Scored");
            Console.WriteLine("{0,-20} {1, 5} {2, 5} {3, 11}", "------", "------", "-------", "   ------------");
            foreach (Team t in teamQuery2)
            {
                //Console.WriteLine("{0,1}", t.);
                Console.WriteLine("{0,-20} {1,5} {2,6} {3,12}", t.TeamName, t.wins, t.era, t.runs);
            }

            Console.WriteLine("Sorted by Number of Runs Scored Ascending\n\n");
            Console.WriteLine("{0,-20} {1, 5}", "Team", "  E.R.A");
            Console.WriteLine("{0,-20} {1, 5}", "------",  "-------");
            foreach (Team t in teamQuery3)
            {
                Console.WriteLine("{0,-20} {1,5}", t.TeamName, t.era);
            }

            Console.WriteLine("Sorted By E.R.A Ascending\n\n");
            Console.WriteLine("{0,-20} {1, 5}", "Team", "Runs per Win");
            Console.WriteLine("{0,-20} {1, 5}", "------", "-----------");
            foreach (string t in teamQuery4)
            {
                Console.WriteLine(t);
            }
            Console.WriteLine("Sorted by Runs Per Win Ascending");
            Console.ReadKey();
        }
    }
}
