﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace dseproject7
{
    public partial class Form1 : Form
    {
        List<Movie> movies = new List<Movie>();

        public Form1()
        {
            InitializeComponent();
        }

        private void btnAddMovie_Click(object sender, EventArgs e)
        {
            addMovie();
        }

        private void addMovie()
        {
            if(txtTitle.Text != "" && txtCategory.Text != "")
            {
                string mt = txtTitle.Text;
                string mc = txtCategory.Text;
                int my = (int)nudYear.Value;

                Movie m = new Movie(mt, mc, my);
                movies.Add(m);
                clearFields();
                txtTitle.Focus();
            }
            else
            {
                MessageBox.Show("Please fill out all of the fields.");
            }
        }

        private void clearFields()
        {
            txtTitle.Text = "";
            txtCategory.Text = "";
            nudYear.Value = 2000;
        }

        private void listMovies()
        {
            lstResults.Items.Clear();
            foreach(Movie ml in movies)
            {
                lstResults.Items.Add(ml.moviename);
            }
        }

        private void saveToFile()
        {
            string fileName = @"C:\Projects\Movies.txt";
            StreamWriter wr = new StreamWriter(fileName);
            foreach(Movie m in movies)
            {
                wr.WriteLine(m.saveMovie());
            }
            wr.Flush();
            wr.Close();
        }

        private void exitProg()
        {
            Application.Exit();
        }

        private void btnClearFields_Click(object sender, EventArgs e)
        {
            clearFields();
        }

        private void btnListMovies_Click(object sender, EventArgs e)
        {
            listMovies();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            saveToFile();
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            exitProg();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            exitProg();
        }

        private void addMovieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            addMovie();
        }

        private void clearFieldsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            clearFields();
        }

        private void listMovieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listMovies();
        }

        private void saveToFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveToFile();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Program By: David Eisenberg\nProject 7\n4-8-2014");
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
        }

        private void nudYear_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)13)
            {
                addMovie();
            }
        }
    }
}
